



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Spring Boot 2.0 配置图文教程</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Spring Boot 2.0 配置图文教程</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 11:05:09 </span>
						</div>
										<div class="post-content">
											
		<div>
<div>摘要: 原创出处 https://www.bysocket.com 「公众号：泥瓦匠BYSocket 」欢迎关注和转载，保留摘要，谢谢！</div>
<p>本章内容</p>
<ol><li>自定义属性快速入门</li>
<li>外化配置</li>
<li>自动配置</li>
<li>自定义创建 Starter 组件</li></ol>
<p>摘录：读书是读完这些文字还要好好用心去想想，写书也一样，做任何事也一样</p>
<p><img referrerpolicy="no-referrer"src="http://springforall.ufile.ucloud.com.cn/static/img/9ebfd97b481d9bda2623e4c80a1746601515130" /></p>
<p>图 2 第二章目录结构图</p>
<h1>第 2 章 Spring Boot 配置</h1>
<p>Spring Boot 配置，包括自动配置和外化配置。本章先实现自定义属性工程，将属性外化配置在 application.properties 应用配置文件，然后在工程中获取该属性值。接着会详细介绍属性的获取方式、外化配置和自动配置。最后会介绍利用自动配置自定义 Start 组件。</p>
<h2>2.1 快速入门工程</h2>
<p>第一章的&nbsp;<code>HelloBookController</code>&nbsp;控制层中，在代码中以硬编码的方式使用字符串表示书信息。下面把书的信息作为属性，外化配置在 application.properties 。好处是将应用参数、业务参数或第三方参数等统一配置在应用配置文件中，避免配置侵入业务代码，达到可配置的方式，方便及时调整修改。</p>
<h3>2.1.1 配置属性</h3>
<p>新建工程命名为 chapter-2-spring-boot-config ，在 application.properties 中配置书名和作者，配置如下：</p>
<pre class="prettyprint linenums"><code>## 书信息<br />
demo.book.name=[Spring Boot 2.x Core Action]<br />
demo.book.writer=BYSocket<br />
</code></pre>
<p>.properties 文件的每行参数被存储为一对字符串，即一个存储参数名称，被称为键；另一个为值。一般称为键值对配置。井号（#）或者英文状态下的叹号（!）作为第一行中第一个非空字符来表示该行的文本为注释。另外，反斜杠（\）用于转义字符。</p>
<p>Spring Boot 支持并推荐使用 YAML 格式的配置文件，将 application.properties 文件替换成 application.yml 文件，并配置相同的属性，配置如下：</p>
<pre class="prettyprint linenums"><code>## 书信息<br />
demo:<br />
    book:<br />
        name: 《Spring Boot 2.x 核心技术实战 - 上 基础篇》<br />
        writer: 泥瓦匠BYSocket<br />
</code></pre>
<p>YAML 是一个可读性高，用来表达数据序列的格式。表示键值对格式时，注意键和值由冒号及空白字符分开。强调下，空白字符是必须的，IDE 一般也会提示。两种配置方式都非常便捷，在开发中选择 .properties 或 .yml 文件配置。但如果两种配置文件同时存在的时候，默认优先使用 .properties 配置文件。YAML 与 .properties 配置文件对比如图 2-1 所示：</p>
<p><img referrerpolicy="no-referrer"src="http://springforall.ufile.ucloud.com.cn/static/img/3ed365aaf6a3e0dbdf1be557a87708391515130" /></p>
<p>图 2-1 YAML 与 .properties 配置文件对比</p>
<p>注意：</p>
<p>在 application.properties 配置中文值，读取时会出现中文乱码问题。因为 Java .properties 文件默认编码方式是 iso-8859 ，Spring Boot 应用以 UTF-8 的编码方式读取，就导致出现乱码问题。</p>
<p>官方 Issue 中的解决方法是，将 .properties 文件中配置的中文值转义成 Unicode 编码形式。例如&nbsp;<code>demo.book.writer=泥瓦匠</code>&nbsp;应该配置成&nbsp;<code>demo.book.writer=\u6ce5\u74e6\u5320</code>&nbsp;。利用 IDEA properties 插件 或利用 Java 文件转码工具 native2ascii 来快速地进行转义。该工具有在线版实现，地址如下：<br />https://javawind.net/tools/native2ascii.jsp</p>
<h3>2.1.2 创建属性类</h3>
<p>在工程中新建包目录&nbsp;<code>demo.springboot.config</code>&nbsp;，并在目录中创建名为 BookProperties 的属性类，代码如下：</p>
<pre class="prettyprint linenums"><code>import org.springframework.beans.factory.annotation.Value;<br />
import org.springframework.stereotype.Component;

/**<br />
 * 书属性<br />
 */<br />
@Component<br />
public class BookProperties {

    /**<br />
     * 书名<br />
     */<br />
    @Value("${demo.book.name}")<br />
    private String name;

    /**<br />
     * 作者<br />
     */<br />
    @Value("${demo.book.writer}")<br />
    private String writer;

    // ... 省略 getter / setter 方法<br />
}<br />
</code></pre>
<p>利用&nbsp;<code>@Component</code>&nbsp;注解定义了书的属性 Bean，并通过&nbsp;<code>@Value</code>&nbsp;注解为该 Bean 的成员变量（或者方法参数）自动注入 application.properties 文件的属性值。<code>@Value</code>&nbsp;注解是通过 &ldquo;${propName}&rdquo; 的形式引用属性，propName 表示属性名称。</p>
<p>核心注解的知识点：</p>
<ul><li>@Component 注解：<br /><code>@Component</code>&nbsp;对类进行标注，职责是泛指组件 Bean ，应用启动时会被容器加载并加入容器管理。常见的&nbsp;<code>@Controller</code>、<code>@Service</code>&nbsp;、<code>@Repository</code>&nbsp;是&nbsp;<code>@Component</code>&nbsp;的分类细化组件，分别对应控制层、服务层、持久层的 Bean。</li>
<li><p>@Value 注解：<br /><code>@Value</code>&nbsp;对 Bean 的字段或者方法参数进行标注，职责是基于表达式给字段或方法参数设置默认属性值。通常格式是注解 + SpEL 表达式，如&nbsp;<code>@Value("SpEL 表达式")</code>。</p></li></ul>
<p>使用&nbsp;<code>@Vlaue</code>&nbsp;注解来引用属性值时，确保所引用的属性值在 application.properties 文件存在并且相对应匹配，否则会造成 Bean 的创建错误，引发&nbsp;<code>java.lang.IllegalArgumentException</code>&nbsp;非法参数异常。</p>
<h3>2.1.3 获取属性</h3>
<p>修改原有的&nbsp;<code>HelloBookController</code>&nbsp;类，通过注入的方式获取书属性 Bean 并返回。代码如下：</p>
<pre class="prettyprint linenums"><code>import demo.springboot.config.BookProperties;<br />
import org.springframework.beans.factory.annotation.Autowired;<br />
import org.springframework.web.bind.annotation.GetMapping;<br />
import org.springframework.web.bind.annotation.RestController;

@RestController<br />
public class HelloBookController {

    @Autowired<br />
    BookProperties bookProperties;

    @GetMapping("/book/hello")<br />
    public String sayHello() {<br />
        return "Hello， " + bookProperties.getWriter() + " is writing "<br />
                + bookProperties.getName() + " ！";<br />
    }<br />
}<br />
</code></pre>
<p>通过&nbsp;<code>@Autowired</code>&nbsp;注解标记在&nbsp;<code>BookProperties</code>&nbsp;字段，控制层自动装配属性 Bean 并使用。默认情况下要求被注解的 Bean 必须存在，需要允许 NULL 值，可以设置其 required 属性为 false：&nbsp;<code>@Autowired(required = false)</code>。</p>
<h3>2.1.4 运行工程</h3>
<p>执行&nbsp;<code>ConfigApplication</code>&nbsp;类启动，在控制台看到成功运行的输出后，打开浏览器访问 /book/hello 地址，可以看到如图 2-2 所示的返回结果：</p>
<p><img referrerpolicy="no-referrer"src="http://springforall.ufile.ucloud.com.cn/static/img/d9aea1949788d79ea24568536856e3c51515130" /></p>
<p>图 2-2 Hello Book 页面</p>
<p>也可以通过单元测试的方式验证属性获取是否成功，单元测试具体相关的会在第 9 章节介绍。单元测试代码如下：</p>
<pre class="prettyprint linenums"><code>import demo.springboot.config.BookProperties;<br />
import org.junit.Assert;<br />
import org.junit.Test;<br />
import org.junit.runner.RunWith;<br />
import org.springframework.beans.factory.annotation.Autowired;<br />
import org.springframework.boot.test.context.SpringBootTest;<br />
import org.springframework.test.context.junit4.SpringRunner;

@RunWith(SpringRunner.class)<br />
@SpringBootTest<br />
public class ConfigApplicationTests {<br />
    @Autowired<br />
    BookProperties bookProperties;

    @Test<br />
    public void testBookProperties() {<br />
        Assert.assertEquals(bookProperties.getName(),"'Spring Boot 2.x Core Action'");<br />
        Assert.assertEquals(bookProperties.getWriter(),"BYSocket");<br />
    }<br />
}<br />
</code></pre>
<h2>2.2 配置属性的获取方式</h2>
<p>配置属性的常用获取方式有基于&nbsp;<code>@Value</code>&nbsp;和&nbsp;<code>@ConfigurationProperties</code>&nbsp;注解两种方式。两种方式适合的场景不同，下面具体介绍其使用方法和场景。</p>
<h3>2.2.1 @Value 注解</h3>
<p><code>@Value</code>&nbsp;注解对 Bean 的变量或者方法参数进行标注，职责是基于表达式给字段或方法参数设置默认属性值。通常格式是注解 + SpEL 表达式，如&nbsp;<code>@Value("SpEL 表达式")</code>，并标注在对应的字段或者方法上方，且必须对变量一一标注。这种方式适用于小而不复杂的属性结构。属性结构复杂，字段很多的情况下，这种方式会比较繁琐，应该考虑使用&nbsp;<code>@ConfigurationProperties</code>&nbsp;注解。</p>
<p>另外通过&nbsp;<code>@PropertySource</code>&nbsp;注解引入对应路径的其他 .properties 文件。将书信息重新配置在 classpath 下新的 book.properties 配置文件后，读取新配置文件的代码如下：</p>
<pre class="prettyprint linenums"><code>import org.springframework.beans.factory.annotation.Value;<br />
import org.springframework.context.annotation.PropertySource;<br />
import org.springframework.stereotype.Component;

/**<br />
 * 书属性<br />
 */<br />
@Component<br />
@PropertySource("classpath:book.properties")<br />
public class BookProperties {

    /**<br />
     * 书名<br />
     */<br />
    @Value("${demo.book.name}")<br />
    private String name;

    /**<br />
     * 作者<br />
     */<br />
    @Value("${demo.book.writer}")<br />
    private String writer;

    // ... 省略 getters / setters 方法<br />
}<br />
</code></pre>
<h3>2.2.2 @ConfigurationProperties 注解</h3>
<p>在包目录&nbsp;<code>demo.springboot.config</code>&nbsp;中创建名为 BookComponent 的属性类，并使用&nbsp;<code>@ConfigurationProperties</code>&nbsp;注解获取属性，代码如下：</p>
<pre class="prettyprint linenums"><code>import org.springframework.boot.context.properties.ConfigurationProperties;<br />
import org.springframework.stereotype.Component;

/**<br />
 * 书属性<br />
 *<br />
 */<br />
@Component<br />
@ConfigurationProperties(prefix = "demo.book")<br />
public class BookComponent {

    /**<br />
     * 书名<br />
     */<br />
    private String name;

    /**<br />
     * 作者<br />
     */<br />
    private String writer;

    // ... 省略 getters / setters 方法<br />
}<br />
</code></pre>
<p>类似&nbsp;<code>@Value</code>&nbsp;注解方式，使用&nbsp;<code>@ConfigurationProperties(prefix = "demo.book")</code>&nbsp;注解标注在类上方可以达到相同的效果。&nbsp;<code>@ConfigurationProperties</code>&nbsp;注解的 prefix 是指定属性的参数名称。会匹配到配置文件中 &ldquo; demo.book.* &rdquo; 结构的属性，星号 &ldquo; * &rdquo; 是指会一一对应匹配&nbsp;<code>BookComponent</code>&nbsp;类的字段名。例如，字段 name 表示书名，会匹配到&nbsp;<code>demo.book.name</code>&nbsp;属性值。</p>
<p><code>@Value</code>&nbsp;注解方式强制字段必须对应在配置文件，&nbsp;<code>@ConfigurationProperties</code>&nbsp;注解方式则不是必须的。一般情况下，所有字段应该保证一一对应在配置文件。如果没有属性值对应的话，该字段默认为空，&nbsp;<code>@ConfigurationProperties</code>&nbsp;注解方式也不会引发任何异常，Spring Boot 推荐使用&nbsp;<code>@ConfigurationProperties</code>&nbsp;注解方式获取属性。</p>
<p>同样使用单元测试验证获取属性是否成功。单元测试代码如下：</p>
<pre class="prettyprint linenums"><code>@Autowired<br />
BookComponent bookComponent;

@Test<br />
public void testBookComponent() {<br />
    Assert.assertEquals(bookComponent.getName(),"'Spring Boot 2.x Core Action'");<br />
    Assert.assertEquals(bookComponent.getWriter(),"BYSocket");<br />
}<br />
</code></pre>
<h5>API org.springframework.boot.context.properties.ConfigurationProperties 注解参数</h5>
<ul><li>prefix<br />字符串值，绑定该名称前缀的属性对象。</li>
<li>value<br />字符串值，功能同 prefix 参数。</li>
<li>ignoreInvalidFields<br />布尔值，默认 false。绑定对象时，忽略无效字段。</li>
<li>ignoreUnknownFields<br />布尔值，默认 true。绑定对象时，忽略未知字段。</li></ul>
<h3>2.2.3 @ConfigurationProperties 数据验证</h3>
<p><code>@ConfigurationProperties</code>&nbsp;注解方式支持验证功能，即当属性类被&nbsp;<code>@Validated</code>&nbsp;注解标注时，Spring Boot 初始化时会验证类的字段。在类的字段上添加 JSR-303 约束注解，进行数据验证。下面为书属性字段添加非 NULL 和字符串非空约束，代码如下：</p>
<pre class="prettyprint linenums"><code>import org.springframework.boot.context.properties.ConfigurationProperties;<br />
import org.springframework.stereotype.Component;<br />
import org.springframework.validation.annotation.Validated;

import javax.validation.constraints.NotEmpty;<br />
import javax.validation.constraints.NotNull;

/**<br />
 * 书属性<br />
 *<br />
 */<br />
@Component<br />
@ConfigurationProperties(prefix = "demo.book")<br />
@Validated<br />
public class BookComponent {

    /**<br />
     * 书名<br />
     */<br />
    @NotEmpty<br />
    private String name;

    /**<br />
     * 作者<br />
     */<br />
    @NotNull<br />
    private String writer;

    // ... 省略 getters / setters 方法<br />
}<br />
</code></pre>
<p>通过&nbsp;<code>@Validated</code>&nbsp;注解开启对&nbsp;<code>BookComponent</code>&nbsp;类字段的数据验证，如果 name 字段为 NULL 或者为空字符串时，会引发&nbsp;<code>BindValidationException</code>&nbsp;绑定数据验证异常。数据验证常用在邮箱格式或者有长度限制的属性字段。另外，验证嵌套属性的值，必须在嵌套对象字段上方标注&nbsp;<code>@Valid</code>&nbsp;注解，用来触发其验证。例如，在书属性中新增嵌套对象出版社&nbsp;<code>Publishing</code>，就需要在该对象上方标注&nbsp;<code>@Valid</code>&nbsp;注解，来开启对&nbsp;<code>Publishing</code>&nbsp;对象的数据验证。综上，两种属性获取方式各有优缺点，对比如图 2-3 所示：</p>
<p><img referrerpolicy="no-referrer"src="http://springforall.ufile.ucloud.com.cn/static/img/9ab13554345f8baada0ff0fae9d226881515130" /></p>
<p>图 2-3 @ConfigurationPropertiesd vs @Value</p>
<h2>2.3 外化配置</h2>
<p>Spring Boot 可以将配置外部化，即分离存储在 classpath 之外，这种模式叫做 &ldquo;外化配置&rdquo;。常用在不同环境中，将配置从代码中分离外置，只要简单地修改下外化配置，可以依旧运行相同的应用代码。外化配置表现形式不单单是 .properties 和 .yml 属性文件，还可以使用环境变量和命令行参数等来实现。那么，多处配置了相同属性时，Spring Boot 是通过什么方式来控制外化配置的冲突呢？答案是外化配置优先级。</p>
<h3>2.3.1 外化配置优先级</h3>
<p>用命令行配置去覆盖 .properties 文件配置方法很简单。正常情况下利用 Java 命令运行工程，代码如下：</p>
<pre class="prettyprint linenums"><code>// chapter-2-spring-boot-config 目录下运行<br />
java -jar target/chapter-2-spring-boot-config-1.0.jar<br />
</code></pre>
<p>下面将书的作者信息 BYSocket 改成 Jeff ， 通过命令行配置覆盖属性，代码如下：</p>
<pre class="prettyprint linenums"><code>java -jar target/chapter-2-spring-boot-config-1.0.jar --demo.book.writer=Jeff<br />
</code></pre>
<p>在命令行配置中，设置属性值的格式是用两个连续的减号 &ldquo;--&rdquo;标志属性。在控制台看到成功运行的输出后，打开浏览器，访问 /book/hello 地址，可以看到如图 2-4 所示的返回结果：</p>
<p><img referrerpolicy="no-referrer"src="http://springforall.ufile.ucloud.com.cn/static/img/b5f58da0340ed3f9218ed1d117c31b581515130" /></p>
<p>图 2-4 书信息被覆盖页面</p>
<p>通过命令行配置覆盖属性提供了非常大的作用与便利性，常见于使用 shell 脚本运行工程时，可以方便地修改工程运行的配置。</p>
<p>但是这就引发了一个问题，岂不让工程很有侵入性，如果开放这个功能，导致未知的安全问题。所以 Spring Boot 提供了屏蔽命令行属性值设置，在应用启动类中设置&nbsp;<code>setAddCommandLineProperties</code>&nbsp;方法为&nbsp;<code>false</code>&nbsp;，用于关闭命令行配置功能，代码如下：</p>
<pre class="prettyprint linenums"><code>SpringApplication.setAddCommandLineProperties(false);<br />
</code></pre>
<p>命令行配置属性的优先级是第四。外化配置获取属性时，会按优先级从高到低获取。如果高优先级存在属性，则返回属性，并忽略优先级低的属性。优先级如下：</p>
<ol><li>本地 Devtools 全局配置</li>
<li>测试时&nbsp;<code>@TestPropertySource</code>&nbsp;注解配置</li>
<li>测试时&nbsp;<code>@SpringBootTest</code>&nbsp;注解的 properties 配置</li>
<li>命令行配置</li>
<li>SPRING_APPLICATION_JSON 配置</li>
<li><code>ServletConfig</code>&nbsp;初始化参数配置</li>
<li><code>ServletContext</code>&nbsp;初始化参数配置</li>
<li>Java 环境的 JNDI 参数配置</li>
<li>Java 系统的属性配置</li>
<li>OS 环境变量配置</li>
<li>只能随机属性的&nbsp;<code>RandomValuePropertySource</code>&nbsp;配置</li>
<li>工程 jar 之外的多环境配置文件（application- {profile}.properties 或 YAML）</li>
<li>工程 jar 之内的多环境配置文件（application- {profile}.properties 或 YAML）</li>
<li>工程 jar 之外的应用配置文件（application.properties 或 YAML）</li>
<li>工程 jar 之内的应用配置文件（application.properties 或 YAML）</li>
<li><code>@Configuration</code>&nbsp;类中的 @PropertySource 注解配置</li>
<li>默认属性配置（<code>SpringApplication.setDefaultProperties</code>&nbsp;指定）</li></ol>
<h3>2.3.2 属性引用</h3>
<p>在 application.properties 中配置属性时，属性之间可以直接通过 &ldquo;${propName}&rdquo; 的形式引用其他属性。比如新增书的描述 description 属性，代码如下：</p>
<pre class="prettyprint linenums"><code>## 书信息<br />
demo.book.name=[Spring Boot 2.x Core Action]<br />
demo.book.writer=BYSocket<br />
demo.book.description=${demo.book.writer}'s${demo.book.name}<br />
</code></pre>
<p>demo.book.description 属性引用了前面定义的 demo.book.name 和 demo.book.writer 属性，其值为 BYSocket's[Spring Boot 2.x Core Action] 。一方面可以使相同配置可以复用，另一方面增强了配置的阅读性。</p>
<h3>2.3.3 使用随机数</h3>
<p>在 application.properties 中配置属性时，可以使用随机数配置，例如注入某些密钥、UUID 或者测试用例，需要每次不是一个固定的值。<code>RandomValuePropertySource</code>&nbsp;类随机提供整形、长整形数、UUID 或者字符串。使用代码如下：</p>
<pre class="prettyprint linenums"><code>my.secret=${random.value}<br />
my.number=${random.int}<br />
my.bignumber=${random.long}<br />
my.uuid=${random.uuid}<br />
my.number.less.than.ten=${random.int(10)}<br />
my.number.in.range=${random.int[1024,65536]}<br />
</code></pre>
<h3>2.3.4 多环境配置</h3>
<p>多环境是指不同配置的生产服务器使用同一工程代码部署，比如：开发环境、测试环境、预发环境、生产环境等。各个环境的工程端口、数据库配置、Redis 配置、日志配置等都会不同，传统模式下需要修改配置，工程重新编译打包，并部署到指定环境服务器。结果是容易发生配置错误，导致开发部署效率低下。Spring Boot 使用多环境配置去解决这个问题。</p>
<p>多环境配置，类似 Maven 构建配置文件的思路，即配置多个不同环境的配置文件，再通过&nbsp;<code>spring.profiles.active</code>&nbsp;命令去指定读取特定配置文件的属性。多环境配置文件是不同于 application.properties 应用配置文件。多环境配置文件的约定命名格式为 application-{profile}.properties。多环境配置功能默认为激活状态，如果其他配置未被激活，则 {profile} 默认为 default，会加载 application-default.properties 默认配置文件，没有该文件就会加载 application.properties 应用配置文件。</p>
<p>多环境配置文件的属性读取方式和从 application.properties 应用配置文件读取方式一致。不管多环境配置文件在工程 jar 包内还是包外，按照配置优先级覆盖其他配置文件。在微服务实践开发中，经常会使用一个类似 deploy 工程去管理配置文件和打包其他业务工程。</p>
<p>在 application.properties 同级目录中，新建 application-dev.properties 作为开发环境配置文件，配置如下：</p>
<pre class="prettyprint linenums"><code>## 书信息<br />
demo.book.name=[Spring Boot 2.x Core Action]  From Dev<br />
demo.book.writer=BYSocket<br />
</code></pre>
<p>新建 application-prod.properties 作为生产环境配置文件，代码如下：</p>
<pre class="prettyprint linenums"><code>## 书信息<br />
demo.book.name=&lt;Spring Boot 2.x Core Action Dev&gt; From Prod<br />
demo.book.writer=BYSocket<br />
</code></pre>
<p>通过命令行指定读取 dev 环境配置文件并运行工程，代码如下：</p>
<pre class="prettyprint linenums"><code>java -jar target/chapter-2-spring-boot-config-1.0.jar --spring.profiles.active=dev<br />
</code></pre>
<p>在多个环境配置中，通过命令&nbsp;<code>--spring.profiles.active=dev</code>&nbsp;指定读取某个配置文件，将 dev 更改成 prod ，轻松切换读取生产环境配置。也可以在控制台的日志中确定配置读取来自 dev ：</p>
<pre class="prettyprint linenums"><code>2017-11-09 12:10:52.978  INFO 72450 --- [           main] demo.springboot.ConfigApplication        : The following profiles are active: dev<br />
</code></pre>
<p>最后打开浏览器，访问 /book/hello 地址，可以看到如图 2-5 所示的返回结果：</p>
<p><img referrerpolicy="no-referrer"src="http://springforall.ufile.ucloud.com.cn/static/img/80fccafce0c406fca72b95064513f7ad1515130" /></p>
<p>图 2-5 dev 环境书信息页面</p>
<h2>2.4 自动配置</h2>
<p>Spring Boot&nbsp;<code>spring-boot-autoconfigure</code>&nbsp;依赖实现了默认的配置项，即应用默认值。这种模式叫做 &ldquo;自动配置&rdquo;。Spring Boot 自动配置会根据添加的依赖，自动加载依赖相关的配置属性并启动依赖。例如默认用的内嵌式容器是 Tomcat ，端口默认设置为 8080。</p>
<p>为什么需要自动配置？顾名思义，自动配置的意义是利用这种模式代替了配置 XML 繁琐模式。以前使用 Spring MVC ，需要进行配置组件扫描、调度器、视图解析器等，使用 Spring Boot 自动配置后，只需要添加 MVC 组件即可自动配置所需要的 Bean。所有自动配置的实现都在&nbsp;<code>spring-boot-autoconfigure</code>&nbsp;依赖中，包括 Spring MVC 、Data 和其它框架的自动配置。</p>
<h3>2.4.1 spring-boot-autoconfigure 依赖</h3>
<p><code>spring-boot-autoconfigure</code>&nbsp;依赖，是 Spring Boot 实现自动配置的核心 Starter 组件。其实现源码包结构如图 2-6 所示：</p>
<p><img referrerpolicy="no-referrer"src="http://springforall.ufile.ucloud.com.cn/static/img/20baaeb5e57f7a44e1722c50a92ccc9c1515130" /></p>
<p>图 2-6 spring-boot-autoconfigure 依赖包目录</p>
<p>从图中可以看出，其中常见核心的包如下：</p>
<pre class="prettyprint linenums"><code>org.springframework.boot.autoconfigure<br />
org.springframework.boot.autoconfigure.data.jpa<br />
org.springframework.boot.autoconfigure.thymeleaf<br />
org.springframework.boot.autoconfigure.web.servlet<br />
org.springframework.boot.autoconfigure.web.reactive<br />
... 省略<br />
</code></pre>
<p>在各自包目录下有对应的自动配置类，代码如下：</p>
<pre class="prettyprint linenums"><code>JpaRepositoriesAutoConfiguration<br />
ThymeleafAutoConfiguration<br />
WebMvcAutoConfiguration<br />
WebFluxAutoConfiguration<br />
... 省略<br />
</code></pre>
<p>上面自动配置类依次是 Jpa 自动配置类、Thymeleaf 自动配置类、Web MVC 自动配置类和 WebFlux 自动配置类。WebFlux 响应式框架会在第 3 章 详细介绍使用。</p>
<p><code>spring-boot-autoconfigure</code>&nbsp;职责是通过&nbsp;<code>@EnableAutoConfiguration</code>&nbsp;核心注解，扫描 ClassPath 目录中自动配置类对应依赖，并按一定规则获取默认配置并自动初始化所需要的 Bean。在 application.properties 配置文件也可以修改默认配置项，常用配置清单地址如下：</p>
<p>https://docs.spring.io/spring-boot/docs/current/reference/html/common-application-properties.html</p>
<h3>2.4.2 @EnableAutoConfiguration 注解</h3>
<p>自动配置工作机制是通过&nbsp;<code>@EnableAutoConfiguration</code>&nbsp;注解中&nbsp;<code>@Import</code>&nbsp;的&nbsp;<code>AutoConfigurationImportSelector</code>&nbsp;自动配置导入选择器类实现的。查阅源码可得具体流程如下：</p>
<ul><li><code>AutoConfigurationImportSelector</code>&nbsp;通过&nbsp;<code>SpringFactoriesLoader.loadFactoryNames()</code>&nbsp;核心方法读取 ClassPath 目录下面的 META-INF/spring.factories 文件。</li>
<li>spring.factories 文件中配置的 Spring Boot 自动配置类，例如常见的&nbsp;<code>WebMvcAutoConfiguration</code>&nbsp;Web MVC 自动配置类和<code>ServletWebServerFactoryAutoConfiguration</code>&nbsp;容器自动配置类 。</li>
<li>spring.factories 文件和 application.properties 文件都属于配置文件，配置的格式均为键值对。里面配置的每个自动配置类都会定义相关 Bean 的实例配置，也会定义什么条件下自动配置和哪些 Bean 被实例化。</li>
<li>当 pom.xml 添加某 Starter 依赖组件的时候，就会自动触发该依赖的默认配置。</li></ul>
<p>例如添加&nbsp;<code>spring-boot-starter-web</code>&nbsp;依赖后，启动应用会触发容器自动配置类。容器自动配置类&nbsp;<code>ServletWebServerFactoryAutoConfiguration</code>&nbsp;的部分代码如下：</p>
<pre class="prettyprint linenums"><code>package org.springframework.boot.autoconfigure.web.servlet;

@Configuration<br />
@ConditionalOnClass({ServletRequest.class})<br />
@ConditionalOnWebApplication(<br />
    type = Type.SERVLET<br />
)<br />
@EnableConfigurationProperties({ServerProperties.class})<br />
@Import({ServletWebServerFactoryAutoConfiguration.BeanPostProcessorsRegistrar.class})<br />
public class ServletWebServerFactoryAutoConfiguration {<br />
... 省略<br />
}

</code></pre>
<p>上面代码中，<code>@ConditionalOnClass</code>&nbsp;注解表示对应的&nbsp;<code>ServletRequest</code>&nbsp;类在 ClassPath 目录下面存在，并且&nbsp;<code>@ConditionalOnWebApplication</code>&nbsp;注解表示该应用是 Servlet Web 应用时，才会去启动容器自动配置，并通过 ServerProperties 类默认设置了端口为 8080。Type.SERVLET 枚举代表 Servlet Web 应用，Type.REACTIVE 枚举代表响应式 WebFlux 应用。</p>
<p>自动配置，是一把双刃剑。用好了就像天下武功唯快不破一样。但要注意一些自动化配置造成的问题。常见的问题有：</p>
<ul><li>Spring Boot 工程添加某些 Starter 组件依赖，又不需要触发组件自动配置</li>
<li>Spring Boot 配置多个不同数据源配置时，使用 XML 配置多数据源，但其默认数据源配置会触发自动配置出现问题。</li></ul>
<p>类似场景下，解决方式是通过 exclude 属性指定并排除自动配置类，代码如下：</p>
<pre class="prettyprint linenums"><code>@SpringBootApplication(exclude = {DataSourceAutoConfiguration.class})<br />
</code></pre>
<p>也等价于配置&nbsp;<code>@EnableAutoConfiguration</code>&nbsp;注解，代码如下：</p>
<pre class="prettyprint linenums"><code>@SpringBootApplication<br />
@EnableAutoConfiguration(exclude = {DataSourceAutoConfiguration.class})<br />
</code></pre>
<p>自动配置会最大的智能化，只有配置了 exclude 属性时，Spring Boot 优先初始化用户定义的 Bean ，然后再进行自动配置。</p>
<h3>2.4.3 利用自动配置自定义 Starter 组件</h3>
<p>当公司需要共享或者开源 Spring Boot Starter 组件依赖包，就可以利用自动配置自定义 Starter 组件。一个完整的 Starter 组件包括以下两点：</p>
<ul><li>提供自动配置功能的自动配置模块。</li>
<li>提供依赖关系管理功能的组件模块，即封装了组件所有功能，开箱即用。</li></ul>
<p>实现自定义 Starter 组件，并不会将这两点严格区分，可以将自动配置功能和依赖管理结合在一起实现。下面利用自动配置实现自定义 Starter 组件：spring-boot-starter-swagger 组件是用来快速生成 API 文档，简化原生使用 Swagger2 。</p>
<p>spring-boot-starter-swagger 组件为 Spring For All 社区（spring4all.com）开源项目，源代码地址是 https://github.com/SpringForAll/spring-boot-starter-swagger。</p>
<h5>什么是 Swagger2</h5>
<p>Swagger2 是 API 最大的开发框架，基于 OpenAPI 规范（OAS），管理了 API 整个生命周期，即从 API 设计到文档，从测试到部署。具体更多了解见其官网，https://swagger.io。</p>
<h5>spring-boot-starter-swagger 组件依赖</h5>
<p>创建一个新的 Spring Boot 工程，命名为 spring-boot-starter-swagger。在 pom.xml 配置相关</p>
<pre class="prettyprint linenums"><code>    &lt;dependencies&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;org.springframework.boot&lt;/groupId&gt;<br />
            &lt;artifactId&gt;spring-boot-starter&lt;/artifactId&gt;<br />
            &lt;optional&gt;true&lt;/optional&gt;<br />
        &lt;/dependency&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;org.springframework.boot&lt;/groupId&gt;<br />
            &lt;artifactId&gt;spring-boot-configuration-processor&lt;/artifactId&gt;<br />
            &lt;optional&gt;true&lt;/optional&gt;<br />
        &lt;/dependency&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;io.springfox&lt;/groupId&gt;<br />
            &lt;artifactId&gt;springfox-swagger-ui&lt;/artifactId&gt;<br />
            &lt;version&gt;${version.swagger}&lt;/version&gt;<br />
        &lt;/dependency&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;io.springfox&lt;/groupId&gt;<br />
            &lt;artifactId&gt;springfox-swagger2&lt;/artifactId&gt;<br />
            &lt;version&gt;${version.swagger}&lt;/version&gt;<br />
        &lt;/dependency&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;io.springfox&lt;/groupId&gt;<br />
            &lt;artifactId&gt;springfox-bean-validators&lt;/artifactId&gt;<br />
            &lt;version&gt;${version.swagger}&lt;/version&gt;<br />
        &lt;/dependency&gt;<br />
        &lt;dependency&gt;<br />
            &lt;groupId&gt;org.projectlombok&lt;/groupId&gt;<br />
            &lt;artifactId&gt;lombok&lt;/artifactId&gt;<br />
            &lt;version&gt;1.16.12&lt;/version&gt;<br />
            &lt;scope&gt;provided&lt;/scope&gt;<br />
        &lt;/dependency&gt;<br />
    &lt;/dependencies&gt;

</code></pre>
<p>配置中添加了&nbsp;<code>spring-boot-starter</code>&nbsp;组件依赖用于自动配置特性，<code>springfox-swagger2</code>&nbsp;依赖是 Swagger2 框架。</p>
<h4>Swagger2 属性配置类 SwaggerProperties</h4>
<p>新建名为&nbsp;<code>SwaggerProperties</code>&nbsp;Swagger2 属性配置类，包含了所有默认属性值。使用该组件时，可以在 application.properties 配置文件配置对应属性项，进行覆盖默认配置。代码如下：</p>
<pre class="prettyprint linenums"><code>import lombok.Data;<br />
import lombok.NoArgsConstructor;<br />
import org.springframework.boot.context.properties.ConfigurationProperties;<br />
import springfox.documentation.schema.ModelRef;

import java.util.ArrayList;<br />
import java.util.LinkedHashMap;<br />
import java.util.List;<br />
import java.util.Map;

@Data<br />
@ConfigurationProperties("swagger")<br />
public class SwaggerProperties {

    /**是否开启swagger**/<br />
    private Boolean enabled;

    /**标题**/<br />
    private String title = "";<br />
    /**描述**/<br />
    private String description = "";<br />
    /**版本**/<br />
    private String version = "";<br />
    /**许可证**/<br />
    private String license = "";<br />
    /**许可证URL**/<br />
    private String licenseUrl = "";<br />
    /**服务条款URL**/<br />
    private String termsOfServiceUrl = "";

    private Contact contact = new Contact();

    /**swagger会解析的包路径**/<br />
    private String basePackage = "";

    /**swagger会解析的url规则**/<br />
    private List&lt;String&gt; basePath = new ArrayList&lt;&gt;();<br />
    /**在basePath基础上需要排除的url规则**/<br />
    private List&lt;String&gt; excludePath = new ArrayList&lt;&gt;();

    /**分组文档**/<br />
    private Map&lt;String, DocketInfo&gt; docket = new LinkedHashMap&lt;&gt;();

    /**host信息**/<br />
    private String host = "";

    /**全局参数配置**/<br />
    private List&lt;GlobalOperationParameter&gt; globalOperationParameters;

     ... 省略，具体代码见 GitHub<br />
}<br />
</code></pre>
<p>用&nbsp;<code>@ConfigurationProperties(prefix = "swagger")</code>&nbsp;标注在类上方是指定属性的参数名称为 swagger。会对应匹配到配置文件中 &ldquo; swagger.* &rdquo; 结构的属性，例如，字段标题 title 表示标题，会匹配到&nbsp;<code>swagger.title</code>&nbsp;属性值。</p>
<h4>Swagger2 自动配置类 SwaggerAutoConfiguration</h4>
<p>新建名为&nbsp;<code>SwaggerAutoConfiguration</code>&nbsp;Swagger2 自动配置类，提供 Swagger2 依赖关系管理功能和自动配置功能。代码如下：</p>
<pre class="prettyprint linenums"><code>import org.springframework.context.annotation.Bean;<br />
import org.springframework.context.annotation.Configuration;<br />
import org.springframework.context.annotation.Import;<br />
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;<br />
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;

@Configuration<br />
@ConditionalOnProperty(name = "swagger.enabled", matchIfMissing = true)<br />
@Import({<br />
        Swagger2DocumentationConfiguration.class,<br />
        BeanValidatorPluginsConfiguration.class<br />
})<br />
public class SwaggerAutoConfiguration implements BeanFactoryAware {

    private BeanFactory beanFactory;

    @Bean<br />
    @ConditionalOnMissingBean<br />
    public SwaggerProperties swaggerProperties() {<br />
        return new SwaggerProperties();<br />
    }

    @Bean<br />
    @ConditionalOnMissingBean<br />
    @ConditionalOnProperty(name = "swagger.enabled", matchIfMissing = true)<br />
    public List&lt;Docket&gt; createRestApi(SwaggerProperties swaggerProperties) {<br />
        ... 省略，具体代码见 GitHub<br />
    }

    @Override<br />
    public void setBeanFactory(BeanFactory beanFactory) throws BeansException {<br />
        this.beanFactory = beanFactory;<br />
    }<br />
}<br />
</code></pre>
<p>上面代码实现流程如下：</p>
<ol><li><code>@Configuration</code>&nbsp;注解标注在类上方，表明该类为配置类。</li>
<li><code>@Import</code>&nbsp;注解引入 Swagger2 提供的配置类&nbsp;<code>Swagger2DocumentationConfiguration</code>&nbsp;和 Bean 数据验证插件配置类&nbsp;<code>BeanValidatorPluginsConfiguration</code>。</li>
<li><code>@ConditionalOnMissingBean</code>&nbsp;注解标注了两处方法，当 Bean 没有被创建时会执行被标注的初始化方法。第一处被标记方法是&nbsp;<code>swaggerProperties()</code>&nbsp;，用来实例化属性配置类&nbsp;<code>SwaggerProperties</code>;第二处被标记方法是&nbsp;<code>createRestApi()</code>， 用来实例化 Swagger2 API 映射的 Docket 列表对象。</li>
<li><code>@ConditionalOnProperty</code>&nbsp;注解标注在&nbsp;<code>createRestApi()</code>&nbsp;方法，name 属性会去检查环境配置项&nbsp;<code>swagger.enabled</code>&nbsp;。默认情况下，属性存在且不是&nbsp;<code>false</code>&nbsp;的情况下，会触发该初始化方法。matchIfMissing 属性默认值为&nbsp;<code>false</code>&nbsp;，这里设置为&nbsp;<code>true</code>，表示如果环境配置项没被设置，也会触发。</li></ol>
<h5>Swagger2 启动注解类 EnableSwagger2Doc</h5>
<p>新建名为&nbsp;<code>EnableSwagger2Doc</code>&nbsp;Swagger2 启动注解类，用于开关 spring-boot-starter-swagger 组件依赖。代码如下：</p>
<pre class="prettyprint linenums"><code>@Target({ElementType.TYPE})<br />
@Retention(RetentionPolicy.RUNTIME)<br />
@Documented<br />
@Inherited<br />
@Import({SwaggerAutoConfiguration.class})<br />
public @interface EnableSwagger2Doc {

}<br />
</code></pre>
<p>上面代码&nbsp;<code>@Import</code>&nbsp;注解引入 Swagger2 自动配置类&nbsp;<code>SwaggerAutoConfiguration</code>。当将该注解配置在应用启动类上方，即可开启 Swagger2 自动配置及其功能。</p>
<h5>使用 spring-boot-starter-swagger 组件依赖</h5>
<p>上面简单介绍了spring-boot-starter-swagger 组件的核心代码实现，同样使用方式也很简单。在 chapter-2-spring-boot-config 工程的 Maven 配置中添加对应的依赖配置，目前支持 1.5.0.RELEASE 以上版本，配置如下：</p>
<pre class="prettyprint linenums"><code>&lt;!-- 自定义 swagger2 Starter 组件依赖 --&gt;<br />
&lt;dependency&gt;<br />
    &lt;groupId&gt;com.spring4all&lt;/groupId&gt;<br />
    &lt;artifactId&gt;spring-boot-starter-swagger&lt;/artifactId&gt;<br />
    &lt;version&gt;2.0&lt;/version&gt;<br />
&lt;/dependency&gt;<br />
</code></pre>
<p>另外，需要在 ConfigApplication 应用启动类上方配置启动注解类&nbsp;<code>EnableSwagger2Doc</code>，代码如下：</p>
<pre class="prettyprint linenums"><code>import com.spring4all.swagger.EnableSwagger2Doc;<br />
import org.springframework.boot.SpringApplication;<br />
import org.springframework.boot.autoconfigure.SpringBootApplication;

@EnableSwagger2Doc // 开启 Swagger<br />
@SpringBootApplication<br />
public class ConfigApplication {<br />
    public static void main(String[] args) {<br />
        SpringApplication.run(ConfigApplication.class, args);<br />
    }<br />
}

</code></pre>
<p>执行&nbsp;<code>ConfigApplication</code>&nbsp;类启动，在控制台看到成功运行的输出后，打开浏览器访问 localhost:8080/swagger-ui.html 地址，可以看到自动生成的 Swagger API 文档，如图 2-7 所示：</p>
<p><img referrerpolicy="no-referrer"src="http://springforall.ufile.ucloud.com.cn/static/img/3e86b26eaa67a2e766dac6292f3487f61515130" /></p>
<p>图 2-7 Swagger API 文档</p>
<h5>API org.springframework.boot.autoconfigure.EnableAutoConfiguration 注解参数</h5>
<ul><li>exclude：<br />Class 数组，排除特定的自动配置类。</li>
<li>excludeName：<br />字符串数组，排除特定名称的自动配置类。</li></ul>
<h5>API org.springframework.boot.autoconfigure.ConditionalOnProperty 注解参数</h5>
<ul><li>havingValue：<br />字符串，属性期望值是否匹配。</li>
<li>matchIfMissing：<br />布尔值，如果该属性值未设置，则匹配。</li>
<li>name：<br />字符串数组，要测试的属性名。</li>
<li>prefix：<br />字符串，属性前缀名。</li>
<li>value：<br />字符串，功能同 name。</li></ul>
<h5>API org.springframework.boot.autoconfigure.ConditionalOnClass 注解参数</h5>
<ul><li>name：<br />字符串数组，类名必须存在。</li>
<li>value：<br />Class 数组，类必须存在。</li></ul>
<h5>API org.springframework.boot.autoconfigure.ConditionalOnMissingBean 注解参数</h5>
<ul><li>annotation：<br />注解 Class 数组，匹配注解装饰的 Bean。</li>
<li>ignored：<br />Class 数组，匹配时，忽略该类型的 Bean。</li>
<li>ignoredType：<br />字符串数组，匹配时，忽略该类型名称的 Bean。</li>
<li>name：<br />字符串数组，匹配要检查的 Bean 名称。</li>
<li>search：<br />SearchStrategy 对象，通过 SearchStrategy 来决定程序的上下文策略。</li>
<li>type：<br />字符串史胡族，匹配要检查的 Bean 类型名称。</li>
<li>value：<br />Class 数组，匹配要检查的 Bean 类型。</li></ul>
<h5>API org.springframework.boot.autoconfigure.ConditionalOnWebApplication 注解参数</h5>
<ul><li>type：<br />ConditionalOnWebApplication.Type 对象，匹配对应的 Web 应用程序类型。</li></ul>
<h2>2.5 本章小结</h2>
<p>本章从自定义属性快速入门工程出发，介绍了两种配置文件以及属性的获取方式，然后讲解了外化配置的优先级、属性引用、随机式使用和多环境配置，最后讲解了自动配置的原理、核心注解以及利用自动配置实现了自定义 Starter 组件。下一章介绍 Spring Boot Web 开发相关。</p>
<p>本章示例代码地址：https://github.com/JeffLi1993/springboot-core-action-book-demo/tree/master/chapter-2-spring-boot-config</p>
<div><img referrerpolicy="no-referrer"src="http://www.bysocket.com/wp-content/uploads/2017/01/qrcode_for_gh_cd421e7eb7d6_430.jpg" />&nbsp;<br />（关注微信公众号，领取 Java 精选干货学习资料）</div>
<div>&nbsp;</div>
</div>																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1v066q.html">Centos7下安装python，查看python版本</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4pev0q.html">tomcat设置虚拟目录开启文件下载在服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvr17y8.html">关于eclipse中DDMS中Emulator Control选项卡为灰色不可用</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw4y0l8.html">修改thinkphp路由模式，去掉Home</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqldk1k9.html">html、css、javascript、JSP 、xml学习顺序应该是怎样的呢？</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kg1m39.html">C语言细节&mdash;&mdash;献给入门者（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvl2oz8.html">atitit&period;&period;&period;触发器机制  ltrigger  mechanism sumup &period;的总结O8f</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m0rn29.html">Android TextUtils类介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yygr0q.html">购买vps创建账号后无法登录ftp</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd1x3gq.html">跟开涛老师学shiro --  INI配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkwxgj8.html">Java 重入锁 ReentrantLock</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p035v8.html">&lbrack;Android&rsqb;Parcelable encountered IOException writing serializable object &lpar;name &equals; xxx&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg5wkm8.html">windows下grunt安装提示不成功</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkogvv8.html">flex chrome浏览器调试flex程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zol05dq.html">通过ArcMap发布服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj6pnx8.html">WPF 自定义TreeView控件样式，仿QQ联系人列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rge1vr8.html">&lbrack;二十二&rsqb;JavaIO之LineNumberReader</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25dy0lq.html">Android测试（三）&mdash;&mdash;burpsuite抓包设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1lmmeq.html">OpenGL ES&colon; 纹理采样 texture sample</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o1onx8.html">Android ListView只加载当前屏幕内的图片（解决list滑动时加载卡顿）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8zozo5dq.html">从group by 展开去</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyg4mm9.html">compress&period;go</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj61d1q.html">Java - Instrumentation</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd4pk79.html">BZOJ&lowbar;2161&lowbar;布娃娃&lowbar;权值线段树</a>
			</li>
						<li><a href="https://www.batexi.com/a/93y4pmg8.html">重构：以Java POI 导出EXCEL为例2</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m3jzn8.html">前端随笔 - JavaScript中的闭包</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy175ndq.html">Vue&period;js-08：第八章 - 组件的基础知识</a>
			</li>
						<li><a href="https://www.batexi.com/a/96prywn8.html">udf提权原理详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd4gv79.html">django&plus;mysql的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy17g72q.html">Python猫荐书系列之五：Python高性能编程</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
